#!/bin/sh

set -a

# set dhcp ip and mac address

SIA_IP=DHCP
SIA_SM=DHCP
SIA_GW=DHCP
SIA_NS=DHCP
SIA_MA=02:03:04:05:06:01

# display ip address, subnet mask, standard gateway, dns server and mac address

echo ----------------------------------------------
echo Set dhcp IP address for interface eth0 + wlan0
echo ----------------------------------------------
echo "IP address  $SIA_IP"
echo "Subnet mask $SIA_SM"
echo "Std gateway $SIA_GW"
echo "DNS server  $SIA_NS"
echo "MAC address $SIA_MA"
echo ----------------------------------------------

# check if /etc is writeable

if [ ! -w /etc/network/interfaces ]; then
  echo
  echo ERROR : File /etc/network/interfaces not writeable, run script via ssh shell
  echo
  exit
fi

# set eth0 static ip address

cat << EOF > /etc/network/interfaces
auto lo
iface lo inet loopback

auto wlan0
iface wlan0 inet dhcp
    pre-up [ -f /media/fat/linux/wpa_supplicant.conf ]
    pre-up wpa_supplicant -s -B -P /run/wpa_supplicant.\$IFACE.pid -i \$IFACE -D nl80211,wext -c /media/fat/linux/wpa_supplicant.conf
    post_up sleep 2
    post-down killall -q wpa_supplicant

auto wlan1
iface wlan1 inet dhcp
    pre-up [ -f /media/fat/linux/wpa_supplicant.conf ]
    pre-up wpa_supplicant -s -B -P /run/wpa_supplicant.\$IFACE.pid -i \$IFACE -D nl80211,wext -c /media/fat/linux/wpa_supplicant.conf
    post_up sleep 2
    post-down killall -q wpa_supplicant
EOF

# enable dhcp client daemon

if [ -f /etc/init.d/disabled.S41dhcpcd ]; then
  mv /etc/init.d/disabled.S41dhcpcd /etc/init.d/S41dhcpcd
fi

# set eth0 mac address

if [ -f /media/fat/linux/u-boot.txt ]; then
  perl -pi -e 'eof && s!$!\nethaddr=$ENV{SIA_MA}! unless s!(ethaddr=)\S+!${1}$ENV{SIA_MA}!;' /media/fat/linux/u-boot.txt
else
  echo "ethaddr=$SIA_MA" > /media/fat/linux/u-boot.txt
fi

# power off message

echo
echo POWER MISTER DEVICE OFF + ON
echo

