#!/bin/sh

set -a

# set ip address, subnet mask, standard gateway, dns server and mac address

SIA_IP=192.168.1.40
SIA_SM=255.255.255.0
SIA_GW=192.168.1.1
SIA_NS=8.8.8.8
SIA_MA=02:03:04:05:06:01

# display ip address, subnet mask, standard gateway, dns server and mac address

echo -----------------------------------------
echo Set static IP address for interface wlan0
echo -----------------------------------------
echo "IP address  $SIA_IP"
echo "Subnet mask $SIA_SM"
echo "Std gateway $SIA_GW"
echo "DNS server  $SIA_NS"
echo "MAC address $SIA_MA"
echo -----------------------------------------

# check if /etc is writeable

if [ ! -w /etc/network/interfaces ]; then
  echo
  echo ERROR : File /etc/network/interfaces not writeable, run script via ssh shell
  echo
  exit
fi

# set eth0 static ip address

cat << EOF > /etc/network/interfaces
auto lo
iface lo inet loopback

auto eth0
iface eth0 inet static
address $SIA_IP
netmask $SIA_SM
gateway $SIA_GW
dns-nameservers $SIA_NS
EOF

# set dns server

cat << EOF > /etc/init.d/S99staticip
#!/bin/sh
echo 'nameserver $SIA_NS' > /etc/resolv.conf
EOF

chmod 755 /etc/init.d/S99staticip

# disable dhcp client daemon

if [ -f /etc/init.d/S41dhcpcd ]; then
  mv /etc/init.d/S41dhcpcd /etc/init.d/disabled.S41dhcpcd
fi

# set eth0 mac address

if [ -f /media/fat/linux/u-boot.txt ]; then
  perl -pi -e 'eof && s!$!\nethaddr=$ENV{SIA_MA}! unless s!(ethaddr=)\S+!${1}$ENV{SIA_MA}!;' /media/fat/linux/u-boot.txt
else
  echo "ethaddr=$SIA_MA" > /media/fat/linux/u-boot.txt
fi

# power off message

echo
echo POWER MISTER DEVICE OFF + ON
echo

