#!/bin/sh

# set ip address, subnet mask, standard gateway and dns server

SIA_IP=192.168.1.41
SIA_SM=255.255.255.0
SIA_GW=192.168.1.1
SIA_NS=8.8.8.8

# display ip address, subnet mask, standard gateway and dns server

echo -----------------------------------------
echo Set static IP address for interface wlan0
echo -----------------------------------------
echo "IP address  : $SIA_IP"
echo "Subnet mask : $SIA_SM"
echo "Std gateway : $SIA_GW"
echo "DNS server  : $SIA_NS"
echo -----------------------------------------

# check if /etc is writeable

if [ ! -w /etc/network/interfaces ]; then
  echo
  echo ERROR : File /etc/network/interfaces not writeable, run script via ssh shell
  echo
  exit
fi

# set wlan0 static ip address

cat << EOF > /etc/network/interfaces
auto lo
iface lo inet loopback

auto wlan0
iface wlan0 inet static
address $SIA_IP
netmask $SIA_SM
gateway $SIA_GW
dns-nameservers $SIA_NS
    pre-up [ -f /media/fat/linux/wpa_supplicant.conf ]
    pre-up wpa_supplicant -s -B -P /run/wpa_supplicant.\$IFACE.pid -i \$IFACE -D nl80211,wext -c /media/fat/linux/wpa_supplicant.conf
    post_up sleep 2
    post-down killall -q wpa_supplicant
EOF

# set dns server

cat << EOF > /etc/init.d/S99staticip
#!/bin/sh
echo 'nameserver $SIA_NS' > /etc/resolv.conf
EOF

chmod 755 /etc/init.d/S99staticip

# disable dhcp client daemon

if [ -f /etc/init.d/S41dhcpcd ]; then
  mv /etc/init.d/S41dhcpcd /etc/init.d/disabled.S41dhcpcd
fi

# power off message

echo
echo POWER MISTER DEVICE OFF + ON
echo

